#include <iostream>

#include <vector>
#include <chrono>


#include "wordcounter.h"

int main(int argc, char* argv[])
{
    size_t num_cores = std::thread::hardware_concurrency();
    std::cout << "Programm running on " << num_cores << " Processor cores" << std::endl;
    std::vector<WordCounter> cores(num_cores < argc? num_cores:argc);
    wordcontainer wordcount;
    size_t coresize = cores.size();

    auto t1 = std::chrono::high_resolution_clock::now();
    for(size_t i = 1,j=0; i < argc;++j)
    {
        if(!cores[j%coresize].isRunning())
        {
            cores[j%coresize].copyWords(wordcount);
            cores[j%coresize].startCounting(argv[i]);
            ++i;
        }
    }
    for(WordCounter& w: cores)
    {
        w.join();
        w.copyWords(wordcount);
    }
    auto t2 = std::chrono::high_resolution_clock::now();
    std::cout << "found " << wordcount.size() << " words" <<std::endl;
    std::cout << "Calculation took " << std::chrono::duration_cast<std::chrono::milliseconds>(t2-t1).count() << " milliseconds" << std::endl;
    /*for(std::pair<const std::string, size_t>& p: wordcount)
    {
        std::cout << p.first << " : " << p.second << std::endl;
    }*/


    return 0;
}

