#ifndef WORDCOUNTER_H
#define WORDCOUNTER_H

#include <string>
#include <thread>
#include <mutex>
#include <unordered_map>
#include <memory>
#include <map>


//#define USE_INMEMORY

#ifndef USE_INMEMORY
typedef std::unordered_map<std::string, size_t> wordcontainer;
#else
#include "memorystring.h"
typedef std::unordered_map<InMemoryString, size_t, MemHash> wordcontainer;
#endif

class WordCounter
{
    std::unique_ptr<std::thread> mythread;
    std::unique_ptr<char[]> data;
    wordcontainer wordcount;
    bool isrunning=false;
    mutable std::mutex mymutex;
    inline bool isWord(const char c);
    void countWordsThreaded(const std::string file);
public:
    WordCounter();
    virtual ~WordCounter();
    WordCounter(const WordCounter& copy);
    WordCounter& operator=(const WordCounter& copy);
    void startCounting(const std::string file);
    void copyWords(wordcontainer &words);
    bool isRunning() const;
    void join();
};

#endif // WORDCOUNTER_H
